# robotframework+python测试框架样例

#### 介绍
robotframework + python的web接口业务测试框架
结合之前做个的云服务器项目部分代码示例供参考

#### 软件架构
仅仅是我的一种框架结构，可灵活自行安排
> 框架目录3个
- lib：python编写底层api接口，robot调用即可
- top：环境配置文件(灵活处理)
- robot： robot脚本文件完成业务功能用例

#### 环境安装
- python3
- (robot版本不一样有略微差别)
- pip3 install robotframework==3.0.4
- pip3 install robotframework-ride
- 运行中需要什么库直接pip安装即可  如requests

#### 说明
- 框架思路适用于web段以及设备端的测试。
- lib层里面封装的常用接口的api，robot负责调用api和自带关键字方法完成逻辑脚本编写，当不会python的人直接会点robot语法就可直接编写脚本，
- 主要是*** Keywords ***的封装和lib接口的封装。
- **文件间的关联：通过Resource和Library**(像python中引用包import一样)
- lib/resource.txt 里面引用python包，robot使用Library；引用txt文件直接Resource 文件路径即可
- 重要：
- 公共复用方法单独封装：参考robot\Ap_web\common_proc.txt
- 功能变量单独文件：   参考robot\urlvar.txt  robot\Ap_web\common_var.txt  top文件
- 接口或者功能函数封装：lib层，以便脚本的维护，比如后期会有上千个.robot的功能脚本,当web和设备端修改了某个接口，我们只需要修改lib里面的函数或者var里面的url地址变量就行了。

#### 运行demo.robot
- 给出了个demo脚本robot\Ap_web\demo.robot

> C:\python3\Scripts\robot.bat(上述装好robotframe后python路径下有的)  -v top:test.txt(top文件) -i test_demo -d ${local_path}\log\  -L Trace -P ${local_path}\lib ${local_path}\robot\Ap_web

- -v 可跟变量文件
- -i 脚本tag
- -P lib路径
- -d 生成log日志
- 可查看run的结果

- robot\Ap_web\Ap_demo.robot就是一个业务功能脚本

- robot官网
- https://robotframework.org/
- 内置关键字方法：http://robotframework.org/robotframework/latest/libraries/BuiltIn.html
